/*
 * Copyright 2006-2007 Queplix Corp.
 *
 * Licensed under the Queplix Public License, Version 1.1.1 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.queplix.com/solutions/commercial-open-source/queplix-public-license/
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 *
 */

package com.queplix.core.client.controls.tree;

/**
 * @author: Vasily Mikhailitchenko
 * @since: 21.09.2006
 */
class QTreeModelImpl implements QTreeModel {

    // ================ model change event declarations
    interface ModelChangeListener {
        void onModelChanged();
    }

    // Single listener model
    // There is only one listener -- QTreeViewImpl, therefore an object, not a list.
    private ModelChangeListener modelChangeListener;

    void addModelChangeListener(ModelChangeListener listener) {
        modelChangeListener = listener;
    }
    // ================ end of model change event declarations

    private QTreeNode rootLevel;

    public QTreeModelImpl() {
        rootLevel = new QTreeNode("", null);
    }

    /**
     * Get the root node of the Tree
     *
     * @return QTreeNode - root node
     */
    public QTreeNode getRoot() {
        return rootLevel;
    }

    /**
     * Add a child to the root node
     *
     * @param child - a node to add
     */
    public void addChild(QTreeNode child) {
        child.setParentNode(rootLevel);
        rootLevel.addChild(child);

        modelChangeListener.onModelChanged();
    }

    /**
     * Remove a child from the root node
     *
     * @param child - a node to remove
     */
    public void removeChild(QTreeNode child) {
        rootLevel.removeChild(child);

        modelChangeListener.onModelChanged();
    }
}
